// **********************************************************************
//
// Generated by the ORBacus IDL-to-C++ Translator
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 4.0a2
// License: non-commercial

#ifndef __PolicyManager_h__
#define __PolicyManager_h__

#include <OB/Policy.h>
#include <OB/Current.h>

namespace OB
{

} // End of namespace OB

namespace CORBA
{

class Policy;
typedef Policy* Policy_ptr;
typedef Policy* PolicyRef;

class Current;
typedef Current* Current_ptr;
typedef Current* CurrentRef;

class PolicyManager;
typedef PolicyManager* PolicyManager_ptr;
typedef PolicyManager* PolicyManagerRef;

} // End of namespace CORBA

void OBDuplicate(CORBA::Policy_ptr);
void OBRelease(CORBA::Policy_ptr);

void OBDuplicate(CORBA::Current_ptr);
void OBRelease(CORBA::Current_ptr);

void OBDuplicate(CORBA::PolicyManager_ptr);
void OBRelease(CORBA::PolicyManager_ptr);

namespace OB
{

} // End of namespace OB

namespace CORBA
{

typedef OB::ObjVar< Policy > Policy_var;
typedef OB::ObjOut< Policy > Policy_out;

typedef OB::ObjVar< Current > Current_var;
typedef OB::ObjOut< Current > Current_out;

typedef OB::ObjVar< PolicyManager > PolicyManager_var;
typedef OB::ObjOut< PolicyManager > PolicyManager_out;

} // End of namespace CORBA

//
// IDL:ooc.com/OB:1.0
//
namespace OB
{
} // End of namespace OB

//
// IDL:omg.org/CORBA:1.0
//
namespace CORBA
{

//
// IDL:omg.org/CORBA/PolicyErrorCode:1.0
//
typedef CORBA::Short PolicyErrorCode;
typedef CORBA::Short_out PolicyErrorCode_out;

//
// IDL:omg.org/CORBA/BAD_POLICY:1.0
//
OB_IMPORT extern const PolicyErrorCode BAD_POLICY;

//
// IDL:omg.org/CORBA/UNSUPPORTED_POLICY:1.0
//
OB_IMPORT extern const PolicyErrorCode UNSUPPORTED_POLICY;

//
// IDL:omg.org/CORBA/BAD_POLICY_TYPE:1.0
//
OB_IMPORT extern const PolicyErrorCode BAD_POLICY_TYPE;

//
// IDL:omg.org/CORBA/BAD_POLICY_VALUE:1.0
//
OB_IMPORT extern const PolicyErrorCode BAD_POLICY_VALUE;

//
// IDL:omg.org/CORBA/UNSUPPORTED_POLICY_VALUE:1.0
//
OB_IMPORT extern const PolicyErrorCode UNSUPPORTED_POLICY_VALUE;

//
// IDL:omg.org/CORBA/PolicyError:1.0
//
struct PolicyError : public CORBA::UserException
{
#ifdef OB_CLEAR_MEM
    PolicyError();
#else
    PolicyError() { }
#endif
    PolicyError(const PolicyError&);
    PolicyError& operator=(const PolicyError&);

    static PolicyError* _downcast(CORBA::Exception*);
    static const PolicyError* _downcast(const CORBA::Exception*);
    virtual void _raise() const { throw *this; }

    virtual CORBA::Exception* _OB_clone() const;
    virtual void _OB_insertInAny(CORBA::Any&);

    PolicyErrorCode reason;

    PolicyError(PolicyErrorCode);
};

//
// IDL:omg.org/CORBA/PolicyManager:1.0
//
// Locality constrained
//
class PolicyManager : public CORBA::Object
{
    PolicyManager(const PolicyManager&);
    void operator=(const PolicyManager&);
    static OB_IMPORT const char* _ob_ids_[];

public:


    PolicyManager() { _ob_locality_ = true; }

    typedef PolicyManager_ptr _ptr_type;
    typedef PolicyManager_var _var_type;

    static inline PolicyManager_ptr
    _duplicate(PolicyManager_ptr p)
    {
        if(p)
            p -> _OB_incRef();
        return p;
    }

    static inline PolicyManager_ptr
    _nil()
    {
        return 0;
    }

    static PolicyManager_ptr _narrow(CORBA::Object_ptr);

    virtual const char** _OB_ids() const;
    static const char** _OB_staticIds();

    //
    // IDL:omg.org/CORBA/PolicyManager/InvalidPolicies:1.0
    //
    struct InvalidPolicies : public CORBA::UserException
    {
        InvalidPolicies() { }
        InvalidPolicies(const InvalidPolicies&);
        InvalidPolicies& operator=(const InvalidPolicies&);

        static InvalidPolicies* _downcast(CORBA::Exception*);
        static const InvalidPolicies* _downcast(const CORBA::Exception*);
        virtual void _raise() const { throw *this; }

        virtual CORBA::Exception* _OB_clone() const;
        virtual void _OB_insertInAny(CORBA::Any&);

        OB::UShortSeq indices;

        InvalidPolicies(const OB::UShortSeq&);
    };

    //
    // IDL:omg.org/CORBA/PolicyManager/get_policy_override:1.0
    //
    virtual Policy_ptr get_policy_override(PolicyType t) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/get_specific_policy_overrides:1.0
    //
    virtual PolicyList* get_specific_policy_overrides(const PolicyTypeSeq& ts) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/get_all_policy_overrides:1.0
    //
    virtual PolicyList* get_all_policy_overrides() = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/add_policy_overrides:1.0
    //
    virtual void add_policy_overrides(const PolicyList& policies) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/remove_policy_overrides:1.0
    //
    virtual void remove_policy_overrides(const PolicyTypeSeq& ts) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/replace_all_policy_overrides:1.0
    //
    virtual void replace_all_policy_overrides(const PolicyList& policies) = 0;

    static void _OB_unmarshal(PolicyManager_ptr&, OB::InputStream&);
};

} // End of namespace CORBA

//
// IDL:ooc.com/OB:1.0
//
namespace OBV_OB
{
} // End of namespace OBV_OB

//
// IDL:omg.org/CORBA:1.0
//
namespace OBV_CORBA
{
} // End of namespace OBV_CORBA

//
// IDL:omg.org/CORBA/PolicyError:1.0
//

//
// IDL:omg.org/CORBA/PolicyManager:1.0
//
namespace CORBA
{

inline void
release(CORBA::PolicyManager_ptr p)
{
    if(p)
        p -> _OB_decRef();
}

inline Boolean
is_nil(CORBA::PolicyManager_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

//
// IDL:omg.org/CORBA/PolicyManager/InvalidPolicies:1.0
//

#endif
